﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="EmployeeServiceClient.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Manage Employees</title>

    <script type="text/javascript">
    
    function pageLoad()
    {
        CallWebMethod("select");
    }
    
    function CallWebMethod(methodType)
    {
        switch(methodType)
        {
            case "select":
                EmployeeService.GetEmployees(FillEmployeeList,ErrorHandler,TimeOutHandler);
                break;
            case "selectone":
                var select=document.getElementById("Select1");
                var empid=select.options[select.selectedIndex].value;
                EmployeeService.GetEmployee(empid,DisplayEmployeeDetails,ErrorHandler,TimeOutHandler);
                break;
            case "insert":
                var text1=document.getElementById("Text1");
                var text2=document.getElementById("Text2");
                EmployeeService.Insert(text1.value,text2.value,InsertEmployee,ErrorHandler,TimeOutHandler);
                break;
            case "update":
                var select=document.getElementById("Select1");
                var empid=select.options[select.selectedIndex].value;
                var text1=document.getElementById("Text1");
                var text2=document.getElementById("Text2");
                
                var emp=new Employee();
                emp.EmployeeID=empid;
                emp.FirstName=text1.value;
                emp.LastName=text2.value;
                
                //EmployeeService.Update(empid,text1.value,text2.value,UpdateEmployee,ErrorHandler,TimeOutHandler);
                EmployeeService.UpdateViaObject(emp,UpdateEmployee,ErrorHandler,TimeOutHandler);
                break;
            case "delete":
                var select=document.getElementById("Select1");
                var empid=select.options[select.selectedIndex].value;
                EmployeeService.Delete(empid,DeleteEmployee,ErrorHandler,TimeOutHandler);
                break;
        }
    }
    
    function FillEmployeeList(result)
    {
        var select=document.getElementById("Select1");
        for(var i=0;i<result.length;i++)
        {
            var option=new Option(result[i].EmployeeID,result[i].EmployeeID);
            select.options.add(option);
        }
    }
    
    function DisplayEmployeeDetails(result)
    {
        var text1=document.getElementById("Text1");
        var text2=document.getElementById("Text2");
        text1.innerText=result.FirstName;
        text2.innerText=result.LastName;
        var lblMsg=document.getElementById("lblMsg");
        lblMsg.innerText="";

    }
    
    function InsertEmployee(result)
    {
        if(result>0)
        {
            var lblMsg=document.getElementById("lblMsg");
            lblMsg.innerText="Employee added successfully!";
        }
        else
        {
            var lblMsg=document.getElementById("lblMsg");
            lblMsg.innerText="Error occured while adding new employee!";
        }
    }

    function UpdateEmployee(result)
    {
        if(result>0)
        {
            var lblMsg=document.getElementById("lblMsg");
            lblMsg.innerText="Employee updated successfully!";
        }
        else
        {
            var lblMsg=document.getElementById("lblMsg");
            lblMsg.innerText="Error occured while updating the employee!";
        }
    }

    function DeleteEmployee(result)
    {
        if(result>0)
        {
            var lblMsg=document.getElementById("lblMsg");
            lblMsg.innerText="Employee deleted successfully!";
        }
        else
        {
            var lblMsg=document.getElementById("lblMsg");
            lblMsg.innerText="Error occured while deleting employee!";
        }
    }
    
    function TimeOutHandler(result)
    {
        alert("Timeout :" + result);
    }

    function ErrorHandler(result)
    {
        var msg=result.get_exceptionType() + "\r\n";
        msg += result.get_message() + "\r\n";
        msg += result.get_stackTrace();
        alert(msg);
    }
    
    </script>

</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" >
            <Services>
                <asp:ServiceReference Path="EmployeeService.asmx" />
            </Services>
        </asp:ScriptManager>
        <div>
            <table>
                <tr>
                    <td colspan="2">
                        <asp:Label ID="Label4" runat="server" Font-Size="X-Large" Text="Employee Management"></asp:Label></td>
                </tr>
                <tr>
                    <td style="width: 100px">
                        <asp:Label ID="Label1" runat="server" Text="Employee ID :"></asp:Label></td>
                    <td style="width: 100px">
                        <select id="Select1" onchange="CallWebMethod('selectone');">
                        </select>
                    </td>
                </tr>
                <tr>
                    <td style="width: 100px">
                        <asp:Label ID="Label2" runat="server" Text="First Name :"></asp:Label></td>
                    <td style="width: 100px">
                        <input id="Text1" type="text" /></td>
                </tr>
                <tr>
                    <td style="width: 100px">
                        <asp:Label ID="Label3" runat="server" Text="Last Name :"></asp:Label></td>
                    <td style="width: 100px">
                        <input id="Text2" type="text" /></td>
                </tr>
                <tr>
                    <td align="center" colspan="2">
                        <input id="Button3" type="button" value="Insert" onclick="CallWebMethod('insert')" />
                        <input id="Button4" type="button" value="Update" onclick="CallWebMethod('update')"/>
                        <input id="Button5" type="button" value="Delete" onclick="CallWebMethod('delete')"/>
                    </td>
                </tr>
                <tr>
                    <td align="center" colspan="2">
                        <span id="lblMsg" style="font-weight: bold; color: red;"></span>
                    </td>
                </tr>
            </table>
        </div>
    </form>
</body>
</html>
